/* Network Trackerd
Copyright Ali BASEL
Ali BASEL <alib@sabanciuniv.edu>, <ali@basel.name.tr>
http://people.sabanciuniv.edu/alib
http://www.basel.name.tr
2004.03.22
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation.
*/

#include "tracker.h"

int config_oku(struct ayr *ayarlar)
{
    char data[256];
    char *ptr;
	FILE *config;

	config=fopen(CONFIG_FILE, "r");
    if( !config) {
        syslog(LOG_INFO, "Couldn't open %s config file !", CONFIG_FILE);
        return 0;
    }

    ayarlar->sqlhost[0]=(char)NULL;
    ayarlar->sqluser[0]=(char)NULL;
    ayarlar->sqlpass[0]=(char)NULL;
	ayarlar->sqldb[0]=(char)NULL;
    ayarlar->ldaphost[0]=(char)NULL;
    ayarlar->ldapbase[0]=(char)NULL;
    ayarlar->ldapmanager[0]=(char)NULL;
    ayarlar->ldapmanagerpass[0]=(char)NULL;    
    
    
	while(fgets(data,132,config)) {
        if ((!*data) || (data[0]=='#')) continue;
        if( (ptr=strstr(data, "SQLHOST=")) ) {
            strncpy(ayarlar->sqlhost, ptr+strlen("SQLHOST="), 128);
            ayarlar->sqlhost[ strlen(ayarlar->sqlhost) -1]=(char)NULL;
        }
        if( (ptr=strstr(data, "SQLUSER=")) ) {
            strncpy(ayarlar->sqluser, ptr+strlen("SQLUSER="), 15);
            ayarlar->sqluser[ strlen(ayarlar->sqluser) -1]=(char)NULL;
        }
        if( (ptr=strstr(data, "SQLPASS=")) ) {
            strncpy(ayarlar->sqlpass, ptr+strlen("SQLPASS="), 15);
            ayarlar->sqlpass[ strlen(ayarlar->sqlpass) -1]=(char)NULL;
        }
		if( (ptr=strstr(data, "SQLDB=")) ) {
            strncpy(ayarlar->sqldb, ptr+strlen("SQLDB="), 15);
            ayarlar->sqldb[ strlen(ayarlar->sqldb) -1]=(char)NULL;
        }
		
        #ifdef HAVE_LDAP
            if( (ptr=strstr(data, "LDAPHOST")) ) {
                strncpy(ayarlar->ldaphost, ptr+strlen("LDAPHOST="), 128);
                ayarlar->ldaphost[ strlen(ayarlar->ldaphost) -1]=(char)NULL;                
            }
            if( (ptr=strstr(data, "LDAPBASE=")) ) {
                strncpy(ayarlar->ldapbase, ptr+strlen("LDAPBASE="), 128);
                ayarlar->ldapbase[ strlen(ayarlar->ldapbase) -1]=(char)NULL;
            }
            if( (ptr=strstr(data, "LDAPMANAGER=")) ) {
                strncpy(ayarlar->ldapmanager, ptr+strlen("LDAPMANAGER="), 128);
                ayarlar->ldapmanager[ strlen(ayarlar->ldapmanager) -1]=(char)NULL;
            }
            if( (ptr=strstr(data, "LDAPMANAGERPASS=")) ) {
                strncpy(ayarlar->ldapmanagerpass, ptr+strlen("LDAPMANAGERPASS="), 30);
                ayarlar->ldapmanagerpass[ strlen(ayarlar->ldapmanagerpass) -1]=(char)NULL;
            }
        #endif
        #ifdef debug
            syslog(LOG_INFO, "Config line data:%s", data);
        #endif
	}
	fclose(config);

    #ifdef debug
        syslog(LOG_INFO, "Config: sqlhost:%s, sqluser:%s, sqlpass:%s, sqldb:%s-", ayarlar->sqlhost, ayarlar->sqluser, ayarlar->sqlpass, ayarlar->sqldb);
        syslog(LOG_INFO, "Config: ldaphost:%s, ldapbase:%s, ldapmanager:%s, ldapmanagerpass:%s-", ayarlar->ldaphost, ayarlar->ldapbase, ayarlar->ldapmanager, ayarlar->ldapmanagerpass);
    #endif

    if( ayarlar->sqlhost[0]==(char)NULL ) {
        syslog(LOG_INFO, "Couldn't find SQLHOST in the %s config file !", CONFIG_FILE);
        return 0;
    }
    if( ayarlar->sqluser[0]==(char)NULL ) {
        syslog(LOG_INFO, "Couldn't find SQLUSER in the %s config file !", CONFIG_FILE);
        return 0;
    }
    if( ayarlar->sqlpass[0]==(char)NULL ) {
        syslog(LOG_INFO, "Couldn't find SQLPASS in the %s config file !", CONFIG_FILE);
        return 0;
    }
    if( ayarlar->sqldb[0]==(char)NULL ) {
        syslog(LOG_INFO, "Couldn't find SQLDB in the %s config file !", CONFIG_FILE);
        return 0;
    }
	#ifdef HAVE_LDAP
        if( ayarlar->ldaphost[0]==(char)NULL ) {
            syslog(LOG_INFO, "Couldn't find LDAPHOST in the %s config file !", CONFIG_FILE);
            return 0;
        }
        if( ayarlar->ldapbase[0]==(char)NULL ) {
            syslog(LOG_INFO, "Couldn't find LDAPBASE in the %s config file !", CONFIG_FILE);
            return 0;
        }
        if( ayarlar->ldapmanager[0]==(char)NULL ) {
            syslog(LOG_INFO, "Couldn't find LDAPMANAGER in the %s config file !", CONFIG_FILE);
            return 0;
        }
        if( ayarlar->ldapmanagerpass[0]==(char)NULL ) {
            syslog(LOG_INFO, "Couldn't find LDAPMANAGERPASS in the %s config file !", CONFIG_FILE);
            return 0;
        }
    #endif    
    return 1;
}
