/* Network Trackerd
Copyright Ali BASEL
Ali BASEL <alib@sabanciuniv.edu>, <ali@basel.name.tr>
http://people.sabanciuniv.edu/alib
http://www.basel.name.tr
2004.03.22
Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation.
*/

#include "tracker.h"
//#define debug

int ip_ekle(char *ip, char *mac, struct ayr *ayarlar)
{
    MYSQL mysql;
    int num_rows;
    char query[500];

    mysql_init(&mysql);

    if(!mysql_real_connect(&mysql, ayarlar->sqlhost, ayarlar->sqluser, ayarlar->sqlpass, ayarlar->sqldb, SQLPORT, NULL, 0)) {
    	syslog(LOG_INFO, "databaze_yaz: Failed to connect to database: Error: %s\n", mysql_error(&mysql));
        return 0;
    }

    sprintf(query, "update macs set ip='%s' where mac='%s'", ip, mac);
    #ifdef debug
        syslog(LOG_INFO, query);
    #endif
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
        syslog(LOG_INFO, "MySQL Error:%s. MAC update query calisamadi ! Query=%s", mysql_error(&mysql), query);
    }
    else { // update query applied
        num_rows=mysql_affected_rows(&mysql);
        if(  num_rows ) { // update basarili, geriye bir data gelmez.
            syslog(LOG_INFO, "IP added; query=%s\n", query);
        }
        else { // update edilemedi insert etmek gerekiyor
            syslog(LOG_INFO, "MAC:%s bulunamadigi icin IP:%s eklenemedi !", mac, ip);
        }
    }
    mysql_close(&mysql);
	return 1;
}
             
    
int database_yaz(struct struct_macler **macler, char *swip, struct ayr *ayarlar, char *zaman)
{
    MYSQL mysql;
    MYSQL_RES *mysqlresult;
    MYSQL_ROW mysqlrow;
    int num_rows, i, ii=-1;
    char query[500], MAC[18];

    mysql_init(&mysql);
    
    if(!mysql_real_connect(&mysql, ayarlar->sqlhost, ayarlar->sqluser, ayarlar->sqlpass, ayarlar->sqldb, SQLPORT, NULL, 0)) {
    	syslog(LOG_INFO, "databaze_yaz: Failed to connect to database: Error: %s\n", mysql_error(&mysql));
        return 0;
    }
    
    while( strcmp( macler[++ii]->mac, "SON") ) {
        mac(macler[ii]->mac, MAC);    
    
        if( !strcmp(macler[ii]->mac, "YOK") ) {
            //printf(" VLAN'de aktif MAC yok !\n");
            continue;
        }
    
        sprintf(query, "select * from macs where mac='%s' and time='%s'", MAC, zaman);
        #ifdef debug
            syslog(LOG_INFO, query);
        #endif
        if( mysql_real_query(&mysql, query, strlen(query)) ) {
    	    syslog(LOG_INFO, "databaze_yaz: Error:%s, Query:%s", mysql_error(&mysql), query);
            continue;
        }
        else { // query succeeded, process any data returned by it
            // DUPLICATE MAC !
    	    mysqlresult = mysql_store_result(&mysql);
            num_rows = mysql_num_rows(mysqlresult);
            for(i=0; i<num_rows; i++) {
			    mysqlrow = mysql_fetch_row(mysqlresult);
			    syslog(LOG_INFO, "databaze_yaz: Duplicate MAC found: MAC=%s, ifname=%s, SwIP=%s, IP=%s, Time=%s", mysqlrow[0], mysqlrow[1], mysqlrow[2], mysqlrow[3], mysqlrow[4]);
                syslog(LOG_INFO, "databaze_yaz: Duplicated MAC: MAC=%s, ifname=%s, swip=%s, time=%s", MAC, macler[ii]->interface_names, swip, zaman);
		    }
	        if( mysqlresult ) mysql_free_result(mysqlresult);
            if( num_rows ) {
                #ifdef debug
                    syslog(LOG_INFO, "database_yaz MAIN: DUPLICATE MAC Sayisi:%d", num_rows);
                #endif
                continue;
            }
        }

        sprintf(query, "update macs set ifname='%s', swip='%s', ip='BOS', time='%s' where mac='%s'", macler[ii]->interface_names, swip, zaman, MAC);
        #ifdef debug
            syslog(LOG_INFO, query);
        #endif
        if( mysql_real_query(&mysql, query, strlen(query)) ) {
    	    syslog(LOG_INFO, "MySQL Error:%s. MAC update query calisamadi ! Query=%s", mysql_error(&mysql), query);
            continue;
        }
        else { // update query applied
            num_rows=mysql_affected_rows(&mysql);
            if(  num_rows ) { // update basarili, geriye bir data gelmez.
                syslog(LOG_INFO, "MAC udated,query=%s\n", query);
                continue;
            }
            else { // update edilemedi insert etmek gerekiyor
                sprintf(query, "insert into macs values ( '%s','%s','%s','BOS','%s','YOK')",MAC,macler[ii]->interface_names, swip, zaman);
                #ifdef debug
                    syslog(LOG_INFO, query);
                #endif
                if( mysql_real_query(&mysql, query, strlen(query)) ) {
    	            syslog(LOG_INFO, "MySQL Error:%s. MAC insert query calisamadi ! Query=%s", mysql_error(&mysql), query);
                    continue;
                }
                else { // insert query applied
                    num_rows=mysql_affected_rows(&mysql);
                    if( num_rows ) { // insert basarili, geriye bir data gelmez.
                        syslog(LOG_INFO, "MAC insert yapildi. Query:%s\n", query);
                        continue;
                    }
                    else { // insert basarisiz
                        syslog(LOG_INFO, "MAC insert edilemedi ! Query=%s", query);
                        continue;                    
                    }
                }
            }
        }            
    }

    
    mysql_close(&mysql);
	return 1;
}


int calculate_statistics(struct ayr *ayarlar)
{
    MYSQL mysql;
    MYSQL_RES *mysqlresult;
    MYSQL_ROW mysqlrow;
	char query[2048];
	char LastUpdateTime[20]; /* Current value of the LastUpdateTime field in the Stats table */
    char LastUpdateFinishTime[20];
	int CurrentTotalMACNumber=0;
	int TotalMACNumber=0;
	int PeakTotalMACNumber=0;
	char PeakTotalMACNumberDate[20];
	int num_rows;
    time_t curtime;
	struct tm *tmb;


	mysql_init(&mysql);
    if(!mysql_real_connect(&mysql, ayarlar->sqlhost, ayarlar->sqluser, ayarlar->sqlpass, ayarlar->sqldb, SQLPORT, NULL, 0)) {
        syslog(LOG_INFO, "calculate_statistics: Failed to connect to database: Error: %s\n", mysql_error(&mysql));
        return 0;
    }


	sprintf(query, "select LastUpdateTime, PeakTotalMACNumber, PeakTotalMACNumberDate from Stats");
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
        syslog(LOG_INFO, "calculate_statistics: Error:%s, Query=%s", mysql_error(&mysql), query);
    }
    else { // query succeeded, process any data returned by it
		mysqlresult = mysql_store_result(&mysql);
		mysqlrow = mysql_fetch_row(mysqlresult);
		strncpy(LastUpdateTime, mysqlrow[0], 20);
		PeakTotalMACNumber=atoi(mysqlrow[1]);
		strncpy(PeakTotalMACNumberDate, mysqlrow[2], 20);
		if( mysqlresult ) mysql_free_result(mysqlresult);
	}
	
	/* Find the current total MAC number */
	sprintf(query, "select count(*) from macs where time='%s'", LastUpdateTime);
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
        syslog(LOG_INFO, "calculate_statistics: Error:%s, Query=%s", mysql_error(&mysql), query);
    }
    else { // query succeeded, process any data returned by it
		mysqlresult = mysql_store_result(&mysql);
		mysqlrow = mysql_fetch_row(mysqlresult);
		CurrentTotalMACNumber=atoi(mysqlrow[0]);
		if( mysqlresult ) mysql_free_result(mysqlresult);
	}
	
	

	if( CurrentTotalMACNumber >= PeakTotalMACNumber ) {
		PeakTotalMACNumber=CurrentTotalMACNumber;
		strncpy(PeakTotalMACNumberDate, LastUpdateTime, 17);
	}
	
	
	/* Find the total MAC number in the database*/
	sprintf(query, "select count(*) from macs");
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
        syslog(LOG_INFO, "calculate_statistics: Error:%s, Query=%s", mysql_error(&mysql), query);
    }
    else { // query succeeded, process any data returned by it
		mysqlresult = mysql_store_result(&mysql);
		mysqlrow = mysql_fetch_row(mysqlresult);
		TotalMACNumber=atoi(mysqlrow[0]);
		if( mysqlresult ) mysql_free_result(mysqlresult);
	}
	
	
	/* Tracking isleminin bittigi zamani belirle */
    time(&curtime); tmb=localtime(&curtime);
    sprintf(LastUpdateFinishTime, "%4d.%02d.%02d-%02d:%02d", tmb->tm_year+1900, tmb->tm_mon+1, tmb->tm_mday, tmb->tm_hour, tmb->tm_min);        
    syslog(LOG_INFO, "calculate_statistics: LastUpdateFinishTime:%s", LastUpdateFinishTime);

	
	
    sprintf(query, "update Stats set Status='sleeping', LastUpdateFinishTime='%s', CurrentTotalMACNumber=%d, PeakTotalMACNumber=%d, PeakTotalMACNumberDate='%s', TotalMACNumber=%d", LastUpdateFinishTime, CurrentTotalMACNumber, PeakTotalMACNumber, PeakTotalMACNumberDate, TotalMACNumber);
    #ifdef debug
        syslog(LOG_INFO, "calculate_statistics:%s", query);
    #endif
    if( mysql_real_query(&mysql, query, strlen(query)) )
        syslog(LOG_INFO, "calculate_statistics: MySQL Error:%s, Query=%s", mysql_error(&mysql), query);
    else { // update query applied
        num_rows=mysql_affected_rows(&mysql);
        syslog(LOG_INFO, "calculate_statistics: Stats udated,query=%s\n", query);
    }

	mysql_close(&mysql);
	return 1;
}


char **router_listesi_al(int *switch_sayisi, struct ayr *ayarlar)
{
    MYSQL mysql;
    MYSQL_RES *mysqlresult;
    MYSQL_ROW mysqlrow;
    int i, num_rows_Main=0, num_rows_Modules=0;
    char query[500], **switchler=NULL;

    mysql_init(&mysql);
    if(!mysql_real_connect(&mysql, ayarlar->sqlhost, ayarlar->sqluser, ayarlar->sqlpass, ayarlar->sqldb, SQLPORT, NULL, 0)) {
    	syslog(LOG_INFO, "switch_listesi_al: Failed to connect to database: Error: %s\n", mysql_error(&mysql));
        mysql_close(&mysql); *switch_sayisi=0; return 0;
    }

    // Find total number of routers for allocating memory= num_rows_Main + num_rows_Modules
    sprintf(query, "select IP from Main where tracking='router'");
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
        syslog(LOG_INFO, "Error:%s, Switch listesi search query'de hata olustu ! Query=%s", mysql_error(&mysql), query);
    }
    else { // query succeeded, process any data returned by it
        mysqlresult = mysql_store_result(&mysql);
        num_rows_Main = mysql_num_rows(mysqlresult);
        if( mysqlresult ) mysql_free_result(mysqlresult);
     }

     
    sprintf(query, "select IP1 from Modules where tracking='router'");
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
        syslog(LOG_INFO, "Error:%s, Router listesi search query'de hata olustu ! Query=%s", mysql_error(&mysql), query);
    }
    else { // query succeeded, process any data returned by it
        mysqlresult = mysql_store_result(&mysql);
        num_rows_Modules = mysql_num_rows(mysqlresult);
        *switch_sayisi=num_rows_Main+num_rows_Modules;
        syslog(LOG_INFO, "num_rows_Modules:%d, num_rows_Main:%d, Total Routers:%d", num_rows_Modules, num_rows_Main, *switch_sayisi);
        switchler = (char **)malloc(*switch_sayisi*sizeof(char *) );
        if( !switchler ) {
            syslog(LOG_ERR, "Couldn't allocate memory for Routers! num_rows_Modules=%d", num_rows_Modules); exit(0);
        }
        for(i=0; i<num_rows_Modules; i++) {
            switchler[i]=(char *)malloc(16); // Memory for one IP address
		    mysqlrow = mysql_fetch_row(mysqlresult);
            strncpy(switchler[i], mysqlrow[0], 15);
        }
	    if( mysqlresult ) mysql_free_result(mysqlresult);
     }

    sprintf(query, "select IP from Main where tracking='router'");
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
        syslog(LOG_INFO, "Error:%s, Router listesi search query'de hata olustu ! Query=%s", mysql_error(&mysql), query);
    }
    else { // query succeeded, process any data returned by it
        mysqlresult = mysql_store_result(&mysql);
        num_rows_Main = mysql_num_rows(mysqlresult);
        for(i=num_rows_Modules; i<*switch_sayisi; i++) {
            switchler[i]=(char *)malloc(16); // Memory for one IP address
		    mysqlrow = mysql_fetch_row(mysqlresult);
            strncpy(switchler[i], mysqlrow[0], 15);
        }
	    if( mysqlresult ) mysql_free_result(mysqlresult);
     }
	mysql_close(&mysql);
    return switchler;
}




char **switch_listesi_al(int *switch_sayisi, struct ayr *ayarlar, char *zaman)
{
    MYSQL mysql;
    MYSQL_RES *mysqlresult;
    MYSQL_ROW mysqlrow;
    int num_rows=0, i;
    char query[500], **switchler=NULL;
    
    mysql_init(&mysql);

    if(!mysql_real_connect(&mysql, ayarlar->sqlhost, ayarlar->sqluser, ayarlar->sqlpass, ayarlar->sqldb, SQLPORT, NULL, 0)) {
    	syslog(LOG_INFO, "switch_listesi_al: Failed to connect to database: Error: %s\n", mysql_error(&mysql));
        mysql_close(&mysql); *switch_sayisi=num_rows; return 0;
    }

    // key=on for switches, key=router for routers-arp table
    sprintf(query, "select IP from Main where tracking='on'");
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
        syslog(LOG_INFO, "switch_listesi_al: Error:%s, Switch listesi search query'de hata olustu ! Query=%s", mysql_error(&mysql), query);
    }
    else { // query succeeded, process any data returned by it
        mysqlresult = mysql_store_result(&mysql);
        num_rows = mysql_num_rows(mysqlresult);
        *switch_sayisi=num_rows;
        switchler=(char **)malloc(num_rows*sizeof(char *) );
        if( !switchler ) {
            syslog(LOG_ERR, "switch_listesi_al: Couldn't allocate memory for switchler! num_switchler=%d", num_rows); exit(0);
        }
        syslog(LOG_INFO, "switch_listesi_al: Total Number of Switches to Track:%d", num_rows);
        for(i=0; i<num_rows; i++) {
            switchler[i]=(char *)malloc(16); // Memory for one IP address
		    mysqlrow = mysql_fetch_row(mysqlresult);
            strncpy(switchler[i], mysqlrow[0], 15);
            //syslog(LOG_INFO, "Switch IP:%s", switchler[i]);
        }
	    if( mysqlresult ) mysql_free_result(mysqlresult);
     }          
	
	
	
	sprintf(query, "update Stats set LastUpdateTime='%s', Status='running'", zaman);
    #ifdef debug
        syslog(LOG_INFO, query);
    #endif
    if( mysql_real_query(&mysql, query, strlen(query)) ) 
        syslog(LOG_INFO, "switch_listesi_al: MySQL Error:%s, Query=%s", mysql_error(&mysql), query);
    else { // update query applied
        num_rows=mysql_affected_rows(&mysql);
        syslog(LOG_INFO, "switch_listesi_al: Query=%s\n", query);
    }

	
	mysql_close(&mysql);
    return switchler;
}


int IPListAlYaz(struct ayr *ayarlar)
{
    MYSQL mysql;
    MYSQL_RES *mysqlresult;
    MYSQL_ROW mysqlrow;
    int num_rows, ipsayisi=0;
    int i, ii;
    char query[500];
	FILE *listeyaz=fopen(LISTE, "w");


    mysql_init(&mysql);
    if(!mysql_real_connect(&mysql, ayarlar->sqlhost, ayarlar->sqluser, ayarlar->sqlpass, ayarlar->sqldb, SQLPORT, NULL, 0)) {
    	syslog(LOG_INFO, "IPListAlYaz: Failed to connect to database: Error: %s\n", mysql_error(&mysql));
        return 0;
    }

    sprintf(query, "select IP from Main");
	#ifdef debug
    	syslog(LOG_INFO, query);
	#endif
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
    	syslog(LOG_INFO, "Error:%s, Query:%s", mysql_error(&mysql), query);
		return 0;
    }
    else { // query succeeded, process any data returned by it
    	mysqlresult = mysql_store_result(&mysql);
        num_rows = mysql_num_rows(mysqlresult);
		#ifdef debug
		syslog(LOG_INFO, "IPListAlYaz MAIN: Bulanan Kayit Sayisi:%d", num_rows);
		#endif
    	for(i=0; i<num_rows; i++) {
			mysqlrow = mysql_fetch_row(mysqlresult);
			if( !mysqlrow[0] ) {
				#ifdef debug
				syslog(LOG_INFO, "IP[%d]= is null", i);
				#endif
				continue;
			}
			#ifdef debug
			syslog(LOG_INFO,"Main IP[%d]:%s", i, mysqlrow[0]);  
			#endif
			if( strlen(mysqlrow[0])>4 && mysqlrow[0][0]!='#' ) {
				fprintf(listeyaz, "%s\n", mysqlrow[0] );
      			ipsayisi++;
			}
		}
		mysql_free_result(mysqlresult);
    }

    sprintf(query, "select IP1, IP2, IP3, IP4, IP5, IP6, IP7, IP8, IP10, IP11, IP12, IP13, IP14, IP15 from Modules");
	#ifdef debug
	syslog(LOG_INFO, query);
	#endif
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
    	syslog(LOG_INFO, "Error:%s, Query:%s", mysql_error(&mysql), query);
		return 0;
    }
    else { // query succeeded, process any data returned by it
    	mysqlresult = mysql_store_result(&mysql);
		num_rows = mysql_num_rows(mysqlresult);
		#ifdef debug
        syslog(LOG_INFO, "IPListAlYaz: MODUL --bulanan Kayit Sayisi:%d", num_rows);
		#endif
	    for(i=0; i<num_rows; i++) {
			mysqlrow = mysql_fetch_row(mysqlresult);
			for(ii=0; ii<13; ii++) {
				if( !mysqlrow[ii] ) {
					#ifdef debug
					syslog(LOG_INFO, "field[%d][%d]= is null", i, ii); 
					#endif
					continue;
				}
				#ifdef debug
				syslog(LOG_INFO, "field[%d][%d], len=%d", i, ii, strlen(mysqlrow[ii]) );
				#endif
				if( strlen(mysqlrow[ii])>4 && mysqlrow[ii][0]!='#' ) {
					fprintf(listeyaz, "%s\n", mysqlrow[ii] );
					ipsayisi++;
				}
			}
		}
		mysql_free_result(mysqlresult);
	}
    mysql_close(&mysql);

	fclose(listeyaz);
	syslog(LOG_INFO, "Listeye eklenen Ip Sayisi:%d", ipsayisi);
	return ipsayisi;
}


int Ayarlar(struct ayr *ayarlar)
{
    MYSQL mysql;
    MYSQL_RES *mysqlresult;
    MYSQL_ROW mysqlrow;
    unsigned num_rows, i;
    int status=0;
    char query[500];

    mysql_init(&mysql);
    if(!mysql_real_connect(&mysql, ayarlar->sqlhost, ayarlar->sqluser, ayarlar->sqlpass, ayarlar->sqldb, SQLPORT, NULL, 0)) {
    	syslog(LOG_INFO, "Ayarlar: Failed to connect to database: Error: %s\n", mysql_error(&mysql));
        return 0;
    }

    sprintf(query, "select * from Ayarlar");
    #ifdef debug
        syslog(LOG_INFO, query);
    #endif
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
    	syslog(LOG_INFO, "Error:%s, Query:%s", mysql_error(&mysql), query);
    }
    else { // query succeeded, process any data returned by it
    	mysqlresult = mysql_store_result(&mysql);
        num_rows = mysql_num_rows(mysqlresult);
        #ifdef debug
            syslog(LOG_INFO, "Ayarlar: Bulanan Kayit Sayisi:%d", num_rows);
        #endif
        if (!num_rows) { // there are no rows
	    	status=-1;
        }
        else { //yani boyle bir kayit varsa
	    	for(i=0; i<num_rows; i++) {
				mysqlrow = mysql_fetch_row(mysqlresult);
	      	    strcpy(ayarlar->MTAHost, mysqlrow[0]);
				strcpy(ayarlar->FromName, mysqlrow[1]);
				strcpy(ayarlar->To1, mysqlrow[2]);
				if( mysqlrow[3] ) strcpy(ayarlar->To2, mysqlrow[3]);				
				else ayarlar->To2[0]=(char)NULL;
				if( mysqlrow[4] ) strcpy(ayarlar->To3, mysqlrow[4]);				
				else ayarlar->To3[0]=(char)NULL;
				strcpy(ayarlar->Subject, mysqlrow[5]);				
				ayarlar->Period=atoi( mysqlrow[6] )*60;	// dakika yapiyor;							
				ayarlar->TrackerRate=atoi( mysqlrow[7] );
                strcpy(ayarlar->Tracking, mysqlrow[8]);
                strcpy(ayarlar->SnmpRO, mysqlrow[9]);
                strcpy(ayarlar->SnmpRW, mysqlrow[10]);
	    	}
	    	status=1;
       	}
	    mysql_free_result(mysqlresult);
    }



    sprintf(query, "select LastUpdateTime from Stats");
    #ifdef debug
        syslog(LOG_INFO, query);
    #endif
    if( mysql_real_query(&mysql, query, strlen(query)) ) {
    	syslog(LOG_INFO, "Error:%s, Query:%s", mysql_error(&mysql), query);
    }
    else { // query succeeded, process any data returned by it
    	mysqlresult = mysql_store_result(&mysql);
        num_rows = mysql_num_rows(mysqlresult);
        #ifdef debug
            syslog(LOG_INFO, "Ayarlar: Bulanan Kayit Sayisi:%d", num_rows);
        #endif
        if (!num_rows) { // there are no rows
	    	strcpy(ayarlar->LastUpdateTime, "never");
        }
        else { //yani boyle bir kayit varsa
		mysqlrow = mysql_fetch_row(mysqlresult);
		strcpy(ayarlar->LastUpdateTime, mysqlrow[0]);
       	}
	mysql_free_result(mysqlresult);
    }

	mysql_close(&mysql);
	return status;
}


void mac(u_char *ptr, char *buf)
{
	register int i, uz=0, yer=0;

	for(i=0; i<6; i++) {
		yer+=uz;
        if( (int)*ptr < 16) sprintf(&buf[yer++], "%c",'0');
		uz=sprintf(&buf[yer], "%x:", *ptr++);
	}
    buf[17]=(char)NULL;
}
